#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <winsock.h>
#include "resource.h"

#define ID_EDIT_URL		1000
#define ID_GO			1001
#define ID_EDIT_VIEW	1002

#define WSOCK_GETHOST	WM_USER + 1	/* zXg̃Cxgʒm郁bZ[W */
#define WSOCK_SELECT	WM_USER + 2	/* \PbgCxgʒm郁bZ[W */

#define BUFSIZE			256			/* obt@TCY */
#define RECVSIZE		4069		/* MTCY */
#define OUTSIZE			32768		/* ~σobt@TCY */

#define ESC 0x1B					/* GXP[vR[h */

// global
HINSTANCE g_hinst;					/* AvP[ṼCX^Xnh */
char gHostEnt[MAXGETHOSTSTRUCT];	/* zXg擾obt@ */
HANDLE hGetHost;					/* zXg擾Ƃ̔񓯊ȃ^XÑnh */
int soc;							/* \PbgiSoket Descriptorj */
char SvName[BUFSIZE];				/* T[o */
char Path[BUFSIZE];					/* pX */
int Port;							/* |[gԍ */
char OUT_BUF[OUTSIZE];				/* M~ςobt@ */

HWND HEdit;							/* M\GfBbg{bNX */
HWND URLEdit;						/* URL͂GfBbg{bNX */
HWND hBTNGET;						/* ʐMJn{^ */

/*---------------------------------------------------
		̃Vtgs
---------------------------------------------------*/
void shift(int *ph,int *pl)
{
	if(*ph & 1){
		if(*pl < 0x60){
			*pl+=0x1F;
		}else{
			*pl+=0x20;
		}
	}else{
		*pl+=0x7E;
	}
	if(*ph < 0x5F){
		*ph = (*ph + 0xE1) >> 1;
	}else{
		*ph = (*ph + 0x161) >> 1;
	}
}

/*---------------------------------------------------
		JISSJISɕϊ
---------------------------------------------------*/
int JIS_SJIS(char *buf,char *ret)
{
	unsigned int c,d,j;
	BOOL jiskanji,hankaku;
	char *p,*r;

	strcpy(ret,"");
	p = buf;
	r = ret;
	j = 0;
	jiskanji = FALSE;
	hankaku = FALSE;
	while(*p != '\0'){
		j++;
		c = *(p++);
		if(c == ESC){
			if((c = *(p++)) == '$'){
				if((c = *(p++)) == '@' || c == 'B'){
					jiskanji = TRUE;
				}else{
					*(r++) = ESC;
					*(r++) = '$';
					if(c != '\0'){
						*(r++) = c;
					}
				}
			}else if(c == '('){
				if((c = *(p++)) == 'H' || c == 'J' || c == 'B'){
					jiskanji = FALSE;
				}else{
					*(r++) = ESC;
					*(r++) = '(';
					if(c != '\0'){
						*(r++) = c;
					}
				}
			}else if(c == '*'){
				if((c = *(p++)) == 'B'){
					hankaku = FALSE;
				}else if(c == 'I'){
					hankaku = TRUE;
				}
			}else if(hankaku == TRUE && c == 'N'){
				c = *(p++);
				*(r++) = c + 0x80;
			}else if(c == 'K'){
				jiskanji = TRUE;
			}else if(c == 'H'){
				jiskanji = FALSE;
			}else{
				*(r++) = ESC;
				if(c != '\0'){
					*(r++) = c;
				}
			}
		}else if(jiskanji && c >= 0x21 && c <= 0x7E){
			if((d = *(p++)) >= 0x21 && d <= 0x7E){
				shift((int *)&c,(int *)&d);
			}
			*(r++) = c;
			if(d != '\0'){
				*(r++) = d;
			}
		}else if(c >= 0xA1 && c <= 0xFE){
			if((d = *(p++)) >= 0xA1 && d <= 0xFE){
				d &= 0x7E;
				c &= 0x7E;
				shift((int *)&c,(int *)&d);
			}
			*(r++) = c;
			if(d != '\0'){
				*(r++) = d;
			}
		}else if(c == 0x0E){
			while(*p != '\0' && *p != 0x0F){
				*(r++) = *(p++) + 0x80;
			}
			if(*p == 0x0F){
				p++;
			}
		}else{
			*(r++) = c;
		}
	}
	*r = '\0';
	return 0;
}

/*---------------------------------------------------
		URLT[oƃpXo֐
---------------------------------------------------*/
int GetURL(char *URL,char *server,char *path)
{
	char *p,*r,*t,wk[8];		/* Ɨp̈ */
	int i,port = 80;

	if(strlen(URL) <= 7){
		return -1;
	}
	/* XL[擾 */
	for(i = 0;i < 7;i++){
		wk[i] = URL[i];
	}
	wk[i] = '\0';
	if(strcmpi(wk,"http://") != 0){
		return -1;
	}

	/* T[o擾 */
	for(p = URL + i,r = server;*p != '/' && *p != '\0';p++,r++){
		*r = *p;
	}
	*r = '\0';

	/* 擾y[W̃pX擾 */
	for(r = path;*p != '\0';p++,r++){
		*r = *p;
	}
	*r = '\0';

	/* T[o:|[g ƂȂĂꍇ͕ */
	for(p = server;*p != ':' && *p != '\0';p++);
	if(*p == ':'){
		for(t = p + 1,r = wk;*t != '\0';t++,r++){
			*r = *t;
		}
		*r = '\0';
		port = atoi(wk);

		*p = '\0';
	}

	/* y[W̎w肪ꍇ́A/ ([g)ݒ肷 */
	if(strcmp(path,"") == 0){
		strcpy(path,"/");
	}
	return port;
}

/*---------------------------------------------------
		ҏW֐
---------------------------------------------------*/
void ConvBuf(char *buf)
{
	char *p,*r;
	char tmp[OUTSIZE];

	/* HTTPX|Xwb_̏I擾 */
	p = (char*)strstr(buf,"\r\n\r\n");			/* wb_̏I肪CRLF CRLF̏ꍇ */
	if(p != NULL){
		p+=4;
	}
	if(p == NULL){
		p = (char*)strstr(buf,"\n\n");			/* wb_̏I肪LF LF̏ꍇ */
		if(p != NULL){
			p+=2;
		}
	}
	if(p == NULL){
		p = (char*)strstr(buf,"\r\r");			/* wb_̏I肪CR CȐꍇ */
		if(p != NULL){
			p+=2;
		}
	}
	if(p == NULL){
		p = (char*)strstr(buf,"\n\r\n\r");		/* wb_̏I肪LFCR LFCȐꍇ */
		if(p != NULL){
			p+=4;
		}
	}
	if(p == NULL){						/* wb_̏I肪Ȃꍇ */
		p = buf;
	}

	/* wb_āAsLF̏ꍇɔCRLFɕϊ */
	for(r = tmp;*p != '\0';p++){
		if(*p == '\n'){
			*(r++) = '\r';
			*(r++) = '\n';
		}else if(*p == '\r'){
		}else{
			*(r++) = *p;
		}
	}
	*r = '\0';

	/* JISSJISɕϊ */
	JIS_SJIS(tmp,buf);
}

/*---------------------------------------------------
		\PbgCxg̒ʒmݒ肷֐
---------------------------------------------------*/
BOOL SocketSelect(int sSoc,HWND hWnd)
{
	/* ڑAMAؒf̃\PbgCxgʒm悤ɐݒ肷 */
	/* \PbgCxǵAEBhEWSOCK_SELECTbZ[WŒʒm悤ɐݒ肷 */
	if(WSAAsyncSelect(sSoc, hWnd, WSOCK_SELECT, FD_CONNECT | FD_READ | FD_CLOSE) == SOCKET_ERROR){
		return FALSE;
	}
	return TRUE;
}

/*---------------------------------------------------
		T[oɐڑvo֐
---------------------------------------------------*/
BOOL ConnectServer(int cSoc,unsigned long cIPaddr,int cPort)
{
	struct	sockaddr_in	serversockaddr;

	/* T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	serversockaddr.sin_family	= AF_INET;
	serversockaddr.sin_addr.s_addr = cIPaddr;						/* IPAhX */
	serversockaddr.sin_port		= htons((unsigned short)cPort);		/* |[gԍ */
	memset(serversockaddr.sin_zero,(int)0,sizeof(serversockaddr.sin_zero));
	/* T[oɃRlNg */
	if(connect(cSoc,(struct sockaddr *)&serversockaddr,sizeof(serversockaddr)) == SOCKET_ERROR){
		if(WSAGetLastError() != WSAEWOULDBLOCK){
			return FALSE;
		}
	}
	return TRUE;
}

/*---------------------------------------------------
		\Pbgj֐
---------------------------------------------------*/
void SocketClose(HWND hWnd)
{
	/* WSAAsyncGetHostByName֐̔񓯊ȃ^XNꍇ̓LZ */
	if(hGetHost != NULL){
		WSACancelAsyncRequest(hGetHost);
		hGetHost = NULL;
	}
	/* \PbgCxg̒ʒm */
	WSAAsyncSelect(soc, hWnd, 0,0);
	/* \Pbgj */
	closesocket(soc);
	soc = -1;

	SetWindowText(hBTNGET,"GO");

}

/*---------------------------------------------------
		\Pbg̃G[֐
---------------------------------------------------*/
void SocketError(HWND hWnd,char *msgbuf)
{
	/* \Pbgj */
	SocketClose(hWnd);

	/* G[bZ[W */
	MessageBox(hWnd,msgbuf,"Error",MB_OK | MB_ICONERROR);

}

/*---------------------------------------------------
		HTTPZbV̊Jn
---------------------------------------------------*/
void HTTPStart(HWND hWnd,char *buf)
{
	unsigned long serveraddr;		/* T[oIPAhX */

	/* URLT[oƃpX擾 */
	Port = GetURL(buf,SvName,Path);
	if(Port == -1){
		MessageBox(hWnd, "URLsłB", "Error", MB_OK | MB_ICONERROR);
		SetWindowText(hBTNGET,"GO");
		return;
	}
	/* socɃ\Pbg쐬܂ */
	soc = socket(PF_INET, SOCK_STREAM, 0);
	if(soc == INVALID_SOCKET){
		MessageBox(hWnd, "Socket̍쐬Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		soc = -1;
		SetWindowText(hBTNGET,"GO");
		return;
	}
	/* svNameɃhbgŋ؂10iIPAhXĂꍇAserveraddr32bitIPAhXԂ܂ */
	serveraddr = inet_addr((char*)SvName);
	if(serveraddr == -1){
		/* T[oT[õzXg擾 */
		/* zXg񂪎擾łƁAEBhEWSOCK_GETHOSTʒm悤ɂ */
		hGetHost = WSAAsyncGetHostByName(hWnd,WSOCK_GETHOST,SvName,gHostEnt, MAXGETHOSTSTRUCT);
		if(hGetHost == 0){
			SocketError(hWnd,"T[oIPAhX̎擾Ɏs܂B");
			return;
		}
		return;
	}
	/* ڑAMAؒf̃CxgEBhEbZ[WŒʒm悤ɂ */
	if(SocketSelect(soc, hWnd) == FALSE){
		SocketError(hWnd,"SocketCxgʒmݒɎs܂B");
		return;
	}

	/* T[oɐڑ */
	if(ConnectServer(soc,serveraddr,Port) == FALSE){
		SocketError(hWnd,"T[oւ̐ڑɎs܂B");
	}
}

/*---------------------------------------------------
		IPAhX擾ĐڑJn
---------------------------------------------------*/
void HTTPGetHostToIPaddr(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	struct hostent FAR *HostEntry;	/* zXg */
	unsigned long serveraddr;		/* T[oIPAhX */

	/* G[̔ */
	if(WSAGETASYNCERROR(lParam) != 0){
		SocketError(hWnd,"T[oIPAhX̎擾Ɏs܂B");
		return;
	}
	/* WSAAsyncGetHostByName̖߂lł񓯊ȃ^XÑnh*/
	if(hGetHost != (HANDLE)wParam){
		return;
	}
	HostEntry = (struct hostent FAR *)gHostEnt;
	serveraddr =  *((unsigned long *)((HostEntry->h_addr_list)[0]));	/* IPAhX擾 */

	hGetHost = NULL;

	/* \PbgCxgEBhEbZ[WŒʒm悤ɂ */
	if(SocketSelect(soc, hWnd) == FALSE){
		SocketError(hWnd,"SocketCxgʒmݒɎs܂B");
		return;
	}

	/* T[oɐڑ */
	if(ConnectServer(soc,serveraddr,Port) == FALSE){
		SocketError(hWnd,"T[oւ̐ڑɎs܂B");
		return;
	}

}

/*---------------------------------------------------
		HTTPNGXg𑗐M
---------------------------------------------------*/
void HTTPSendRequest(HWND hWnd)
{
	char SendBuf[BUFSIZE];			/* Mobt@ */

	/* HTTPNGXg̍쐬 */
	wsprintf(SendBuf,"GET %s HTTP/1.0\r\nHost: %s:%d\r\nUser-Agent: httpcex/0.0\r\n\r\n",Path,SvName,Port);
	/* f[^𑗐M */
	if(send(soc, SendBuf, lstrlen(SendBuf), 0) == SOCKET_ERROR){
		SocketError(hWnd,"MɎs܂B");
		return;
	}
	strcpy(OUT_BUF,"");
}

/*---------------------------------------------------
		f[^MĒ~ς
---------------------------------------------------*/
void HTTPRecvData(HWND hWnd)
{
	char RecvBuf[RECVSIZE];	/* Mobt@ */
	int buf_len;			/* MoCg */

	/* f[^M */
	buf_len = recv(soc, RecvBuf, RECVSIZE - 1, 0);
	if (buf_len == SOCKET_ERROR ){
		SocketError(hWnd,"MɎs܂B");
		return;
	}
	RecvBuf[buf_len] = '\0';		/* Mobt@̌NULLt */
	if((strlen(OUT_BUF) + buf_len) < OUTSIZE){
		strcat(OUT_BUF,RecvBuf);		/* obt@ɎM~ς */
	}
}

/*---------------------------------------------------
		T[oؒf
---------------------------------------------------*/
void HTTPClose(HWND hWnd)
{
	char RecvBuf[RECVSIZE];			/* Mobt@ */
	int buf_len;					/* MoCg */

	/* Mobt@Ƀf[^΂ׂĎM */
	while((buf_len = recv(soc, RecvBuf, RECVSIZE - 1, 0)) > 0 ){
		RecvBuf[buf_len] = '\0';	/* obt@̌NULLt */
		strcat(OUT_BUF,RecvBuf);
	}

	/* \Pbgj */
	SocketClose(hWnd);

	/* GfBbg{bNXɕ̕\s */
	ConvBuf(OUT_BUF);	/* 𐮌` */
	SendMessage(HEdit,WM_SETTEXT,0,(LPARAM) ((LPSTR)OUT_BUF));
}

/*---------------------------------------------------
		CEBhẼvV[W
---------------------------------------------------*/
LONG APIENTRY  MainProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char buf[BUFSIZE];
	RECT WinRec;

	switch (uMsg)
	{
	case WM_CREATE:		/* EBhE쐬 */
		/* EBhẼRg[쐬 */
		URLEdit = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",(LPSTR)NULL,WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOHSCROLL,5,10,300,25,hWnd,(HMENU)ID_EDIT_URL,g_hinst,NULL);
		hBTNGET = CreateWindow("BUTTON",(LPSTR)"GO",WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON,310,10,50,25,hWnd,(HMENU)ID_GO,g_hinst,NULL);
		HEdit = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",(LPSTR)NULL,WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP | ES_NOHIDESEL | ES_MULTILINE | ES_LEFT | ES_READONLY,0,40,0,0,hWnd,(HMENU)ID_EDIT_VIEW,g_hinst,NULL);
		SetFocus(URLEdit);
		/*  */
		soc = -1;
		hGetHost = NULL;

		break;

	case WSOCK_GETHOST:						/* T[õzXg֐̃Cxg */
		/* zXg񂩂IPAhX擾ĐڑJn */
		HTTPGetHostToIPaddr(hWnd,wParam,lParam);
		break;

	case WSOCK_SELECT:						/* \PbgCxg̃bZ[W̏ꍇ(WSAAsyncSelect֐ɂēo^) */
		/* G[̔ */
		if(soc != -1 && WSAGETSELECTERROR(lParam) != 0){
			SocketError(hWnd,"SocketCxg̒ʒmŃG[܂B");
			break;
		}
		/* ׂ\Pbg */
		if(soc != (int)wParam){
			break;
		}
		/* \PbgCxg̏s */
		switch(WSAGETSELECTEVENT(lParam))
		{
		case FD_CONNECT:					/* T[oւ̐ڑCxg */
			/* HTTPNGXg𑗐M */
			HTTPSendRequest(hWnd);
			break;

		case FD_READ:						/* Mobt@Ƀf[^鎖Cxg */
			/* f[^MĒ~ς */
			HTTPRecvData(hWnd);
			break;

		case FD_CLOSE:						/* T[oւ̐ڑICxg */
			/* ڑI */
			HTTPClose(hWnd);
			break;
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case ID_GO:
			if(soc != -1){		/* ɒʐM̏ꍇ̓LZ */
				/* \Pbgj */
				SocketClose(hWnd);
			}else{				/* ʐMJn */
				/* URL擾 */
				SendMessage(URLEdit,WM_GETTEXT,BUFSIZE - 1,(LPARAM)buf);
				SetWindowText(hBTNGET,"Cancel");

				/* HTTPZbVJn */
				HTTPStart(hWnd,buf);
			}
			break;
		}
		break;

	case WM_SIZE:
		/* GfBbg{bNX̃TCYύX */
		GetClientRect(hWnd,(LPRECT)&WinRec);
		SetWindowPos(HEdit,0,0,40,WinRec.right,WinRec.bottom - 40,SWP_NOZORDER);
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_ENDSESSION:
		return 0;

	case WM_CLOSE:
		/* ʐM̏ꍇ̓LZ */
		if(soc != -1){
			/* \Pbgj */
			SocketClose(hWnd);
		}

		/* EBhEj */
		DestroyWindow(hWnd);
		break;

	default:
		return (DefWindowProc(hWnd, uMsg, wParam, lParam));
	}
	return(0);

}

/*---------------------------------------------------
		WinSock̏s֐
---------------------------------------------------*/
BOOL initWinsock(void)
{
	WORD wVersionRequested;
	int  nErrorStatus;
    WSADATA wsaData;

	wVersionRequested = MAKEWORD(1, 1);				/* o[W 1.1 v */
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
    if (atexit((void (*)(void))(WSACleanup))) {		/* IWinSock̃\[X悤ɂĂ */
		MessageBox(NULL, "WinSock̏Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	if ( nErrorStatus != 0 ) {
		MessageBox(NULL, "WinSock̏Ɏs܂B", "Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	return TRUE;
}

/*---------------------------------------------------
		EBhENX̓o^s֐
---------------------------------------------------*/
BOOL InitApplication(HANDLE hInstance)
{
	WNDCLASS  wc;

	/* EBhENXo^ */
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)MainProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICONMAIN));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (void*)COLOR_BTNSHADOW;
	wc.lpszMenuName =  MAKEINTRESOURCE(200);
	wc.lpszClassName = "httpcexMainWindowClass";

	return (RegisterClass(&wc));
}

/*---------------------------------------------------
		EBhE̍쐬s֐
---------------------------------------------------*/
BOOL InitInstance( HANDLE hInstance, int nCmdShow)
{
	HWND hWnd;

	/* EBhE쐬 */
	hWnd = CreateWindow("httpcexMainWindowClass",
		"httpcex Ver 0.0",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		g_hinst,
		NULL
		);

	if (!hWnd){
		return (FALSE);
	}

	/* EBhE\ */
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

    return (TRUE);

}

/*---------------------------------------------------
		C֐
---------------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	g_hinst = hInstance;

	/* WinSock̏s */
	if (!initWinsock()) {
		return FALSE;
	}

	/* EBhENX̓o^s */
	if (!InitApplication(hInstance)){
		return (FALSE);
	}
    /* EBhE̍쐬s */
	if (!InitInstance(hInstance, nCmdShow)){
		return (FALSE);
	}

	/* EBhEbZ[W */
	while (GetMessage(&msg,NULL,0,0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);

}

